﻿using System;
using System.Collections.Generic;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace RusAlgo.Handlers.Public
{
    // индик выдает текущее ГО в моменте. Никаких исторических данных нет и в помине. Только по факту.
    [HandlerCategory("RusAlgo")]
    [HandlerName("ГО на покупку")]
    public class BuyDeposit : IOneSourceHandler, ISecurityInputs, IDoubleReturns, IStreamHandler, IContextUses
    {
        public IContext Context { set; private get; }

        public IList<double> Execute(ISecurity sec)
        {
            var value = sec.FinInfo.BuyDeposit ?? 0;
            var res = new double[Context.BarsCount];
            res.Fill(value);
            return res;
        }
    }

    [HandlerCategory("RusAlgo")]
    [HandlerName("ГО на продажу")]
    public class SellDeposit : IOneSourceHandler, ISecurityInputs, IDoubleReturns, IStreamHandler, IContextUses
    {
        public IContext Context { set; private get; }

        public IList<double> Execute(ISecurity sec)
        {
            var value = sec.FinInfo.SellDeposit ?? 0;
            var res = new double[Context.BarsCount];
            res.Fill(value);
            return res;
        }
    }
}
