﻿using System.Collections.Generic;
using System.Linq;
using TSLab.DataSource;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace RusAlgo.Handlers.Public.TickProcessors
{
    // Индикатор дельты покупки.
    [HandlerCategory("RusAlgo")]
    [HandlerName("BuyVolumeDelta")]
    public class BuyVolumeDelta : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity security)
        {
            var count = security.Bars.Count;
            var values = new double[count];
            for (var i = 0; i < count; i++)
            {
                var trades = security.GetTrades(i);
                var buyVolume = trades.Where(trd => trd.Direction == TradeDirection.Buy).Sum(trd => trd.Quantity);
                var sellVolume = trades.Where(trd => trd.Direction == TradeDirection.Sell).Sum(trd => trd.Quantity);
                var delta = buyVolume / sellVolume;     // Если продажа == 0 то будет бесконечность.
                values[i] = delta;
            }
            return values;

        }
    }

    // Индикатор дельты продажи.
    [HandlerCategory("RusAlgo")]
    [HandlerName("SellVolumeDelta")]
    public class SellVolumeDelta : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity security)
        {
            var count = security.Bars.Count;
            var values = new double[count];
            for (var i = 0; i < count; i++)
            {
                var trades = security.GetTrades(i);
                var buyVolume = trades.Where(trd => trd.Direction == TradeDirection.Buy).Sum(trd => trd.Quantity);
                var sellVolume = trades.Where(trd => trd.Direction == TradeDirection.Sell).Sum(trd => trd.Quantity);
                var delta = sellVolume / buyVolume;     // Если продажа == 0 то будет бесконечность.
                values[i] = delta;
            }
            return values;
        }
    }
}